using System;
using System.Collections.Generic;

struct Etel : IComparable<Etel>
{
    public int id;
    public int szavatossag;
    public bool minoseg;
    public int CompareTo(Etel e2)
    {
        return szavatossag.CompareTo(e2.szavatossag);
    }
}

static class Program
{
    static void Main()
    {
        int N = int.Parse(Console.ReadLine());
        var etelek = new List<Etel>();
        for (int i = 0; i < N; i++)
        {
            string[] s = Console.ReadLine().Split();
            int sz = int.Parse(s[0]);
            int m = int.Parse(s[1]);
            if (m < 4)
                continue;
            etelek.Add(new Etel { id = i + 1, szavatossag = sz, minoseg = m >= 5 });
        }
        etelek.Sort();
        var e4 = new List<int>();
        var e5 = new List<int>();
        foreach (var e in etelek)
        {
            if (e.minoseg && e5.Count < e.szavatossag)
            {
                e5.Add(e.id);
            }
            else if (e4.Count < e.szavatossag)
            {
                e4.Add(e.id);
            }
        }
        while (e5.Count > e4.Count)
        {
            e4.Add(e5[e5.Count - 1]);
            e5.RemoveAt(e5.Count - 1);
        }
        Console.WriteLine(e5.Count);
        for (int i = 0; i < e5.Count; i++)
        {
            Console.WriteLine($"{e4[i]} {e5[i]}");
        }
    }
}