#include <iostream>
#include <deque>

using namespace std;

const int MAXN = 100000;
int N, S[MAXN];
deque<int> aux;

int main() {
    ios::sync_with_stdio(false);
    cin >> N;
    for (int i = 0; i < N; ++i)
        cin >> S[i];
    
    int nxt = 1;
    for (int i = 0; i <= N; ++i) {
        while (!aux.empty() && aux.front() == nxt) {
            aux.pop_front();
            ++nxt;
        }
        if (S[i] == nxt)
            ++nxt;
        else
            aux.push_back(S[i]);
    }
    cout << nxt - 1 << endl;

    return 0;
}
